package ovh.herisson.thevoidroad.Commands;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.WorldBorder;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Player;

import net.kyori.adventure.text.Component;
import ovh.herisson.thevoidroad.DatabaseManager;
import ovh.herisson.thevoidroad.TheVoidRoad;
import ovh.herisson.thevoidroad.Voids;
import ovh.herisson.thevoidroad.Entity.Merchand;

public class VoidCommands implements CommandExecutor, TabCompleter{
	private final Merchand m = Merchand.getInstance();

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
		for (int i = 0; i < args.length; i++) {
			args[i] = args[i].toLowerCase();
		}
		if(args.length < 1){
			if(sender instanceof Player ply){
				sender.sendMessage("You got: "+Voids.get(ply) + TheVoidRoad.CoinGlyph);
				return true;
			}
			return false;
		}
		switch (args[0]) {
			case "score":
				Voids.scoreboard().forEach((p, a) -> {
					sender.sendMessage(p + " : " + a);
				});
				return true;
			case "give": 
				if(args.length < 2) return false;
				Player target = Bukkit.getPlayer(args[1]);
				if(target != null && sender instanceof Player ply && Integer.parseInt(args[2]) > 0)
					Voids.give(ply,target, Integer.parseInt(args[2]));
				break;
			case "event": 
				//TODO(event) manage event 
				return true;
			case "manage": 
				if(!sender.hasPermission("void.manage") || args.length < 2) return false;
				switch (args[1]) {
					case "setspawn": 
						return setspawn(sender);
					case "init":
						m.regenerate();
						Bukkit.getServer().sendMessage(Component.text(m.getLocation().toString()));
						DatabaseManager.getInstance().setConfig("init", "true");
						return true;
					case "reset":
						DatabaseManager.getInstance().setConfig("init", "false");
						break;
					case "unban":
						UUID target_uuid = Bukkit.getPlayerUniqueId(args[2]);
						DatabaseManager.getInstance().unban(target_uuid);
						return true;
					case "skip":
						//TODO(Merchand): Skip trade
						break;
					case "goto":
						if(sender instanceof Player ply && m.getLocation() != null){
							ply.teleport(m.getLocation());
						}else{
							sender.sendMessage("You can't teleport!");
						}
						break;
					case "balance":
						if(args.length < 5) return false;
						switch (args[2]) {
							case "set": 
								Player target_ = Bukkit.getPlayer(args[3]);
								Voids.set(target_, Integer.parseInt(args[4]));
								return true;
							case "add":
							case "sub": 
								sender.sendMessage("TODO"); //TODO
						}
						return false;
				}
				break;
		}
		return true;
    }

	private boolean setspawn(CommandSender sender){
		if(sender instanceof Player ply){
			Location loc = ply.getLocation();
			WorldBorder border = ply.getWorld().getWorldBorder();

			ply.getWorld().setSpawnLocation(loc);
			border.setCenter(loc);
			border.setSize(750);
			return true;
		}
		return false;
	}

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) { //TODO: add all commands
		ArrayList<String> list = new ArrayList<>();

		if(args.length == 1){
			list.addAll(List.of("give","event", "score"));
			if(sender.hasPermission("void.manage")){
				list.add("manage");
			}
		}
		if(args.length >= 2){
			switch (args[0]) {
				case "give": 
					return null;
				case "event":
					return list;
				case "manage":
					if(sender.hasPermission("void.manage")){
						if(args[1] == "balance" && args.length <= 3){
							list.addAll(List.of("set", "add", "sub"));
							return list;
						}
						list.addAll(List.of("setspawn", "init", "skip", "reset", "balance")); //TODO: should add balance management
					}
					return list;
			}
		}
		return list;
    }
}
